unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Windows, Useful;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1:   TButton;
    CheckBox1: TCheckBox;
    Edit1:     TEdit;
    Edit2:     TEdit;
    Edit3:     TEdit;
    Label1:    TLabel;
    Label2:    TLabel;
    Label3:    TLabel;
    Label4:    TLabel;
    Label5:    TLabel;
    NANINFO:   TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure NANINFOClick(Sender: TObject);
    function SetRes(filename, resname, resvalue: string; resid: word;
      delex: boolean): boolean;
    procedure Chk;
  private
    { private declarations }
  public
    { public declarations }
  end;

const
  d = '   ';

var
  Form1: TForm1;
  x, f, f2: string;
  qq: boolean;

implementation

{ TForm1 }

procedure TForm1.Chk;
begin
  f := read1(x);
  if not FileExists(f) then
  begin
    if qq then
      f := InputBox('A->B', 'Pfad eingeben', '');
    if (f = '') then
    begin
      qq := False;
      Application.Terminate;
    end;
    write1(x, f);
    Chk;
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  qq := True;
  x  := AktuellerPfad + 'pfad.txt';
  Chk;
  f2 := AktuellerPfad + 'B.exe';
end;

procedure TForm1.NANINFOClick(Sender: TObject);
begin
  ShowMessage('Nur Zahlen erlaubt.');
end;


function TForm1.SetRes(filename, resname, resvalue: string; resid: word;
  delex: boolean): boolean;
var
  hUpdate: THandle;
  Size:    DWord;
begin
  hUpdate := BeginUpdateResource(PChar(filename), delex);
  if (hUpdate <> 0) and (hUpdate <> INVALID_HANDLE_VALUE) then
  begin
    try
      Size   := Succ(Length(resvalue)) * SizeOf(char);
      Result := UpdateResource(hUpdate, RT_RCDATA, PChar(resname),
        resid, PChar(resvalue), Size);
    finally
      EndUpdateResource(hUpdate, False);
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  XCopy(f, f2);
  Delay(Random(333) + 333);
  if not SetRes(f2, Edit1.Text, Edit2.Text, StrToInt(Edit3.Text),
    CheckBox1.Checked) then
  begin
    ShowMessage('Fehler beim Schreiben der Resource.');
    Exit;
  end;
  Delay(Random(333) + 333);
  if not Run(f2) then
    ShowMessage('not found:' + sLineBreak + f2 + d);
end;

procedure TForm1.Edit3Change(Sender: TObject);
begin
  NANINFO.Visible := not IsNumeric(Edit3.Text);
end;


initialization
  {$I unit1.lrs}

end.

